﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ProdCons{

    /* Produttore. Genera caratteri casuali e li inserisce nel buffer a ciclo continuo. 
       Generato il numero massimo di valori inserisce 0 (zero) nel buffer per indicare al
       consumatore che l'esecuzione è terminata */
    class Producer{
        private int nValues;
        private SynchronizedBuffer buffer;
        private Random rand = new Random();

        public Producer(SynchronizedBuffer buffer, int nValues){
            this.buffer = buffer;
            this.nValues = nValues;
        }

        public void produce(){
            char value;
            int i = 0;
            Console.WriteLine("Produttore: esecuzione iniziata");
            do{
                if (i < nValues)
                    value = (char)(rand.Next(65, 90));
                else
                    value = '0';
                buffer.addElement(value);
                Console.WriteLine("Produttore: ho inserito il valore " + value);
                i++;
            }while(i <= nValues);
            Console.WriteLine("Produttore: esecuzione terminata");
        }
    }
}
