﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace ProdCons{

    public class SynchronizedBuffer
    {
        /* Array che contiene gli elementi del buffer */
        private char[] buffer;
        /* Prossimo elemento da scrivere */
        private int nextElement = 0;
        /* Primo elemento da leggere */
        private int firstElement = 0;
        /* Elementi scritti sul buffer */
        private int elements = 0;
        /* Semafori per la sincronizzazione */
        SemaphoreSlim SemaphoreSpace; //Spazio disponibile
        SemaphoreSlim SemaphoreData; //Dati disponibili

        public SynchronizedBuffer(int elements)
        {
            buffer = new char[elements];
            SemaphoreSpace = new SemaphoreSlim(elements, elements); //Spazio disponibile
            SemaphoreData = new SemaphoreSlim(0, elements); //Dati disponibili
        }

        /* Aggiunge un elemento al buffer. */
        public void addElement(char value)
        {
            SemaphoreSpace.Wait();
            lock (buffer.SyncRoot)
            {
                buffer[nextElement] = value;
                nextElement = (nextElement + 1) % buffer.Length;
                elements++;
            }
            SemaphoreData.Release();
        }

        /* Restituisce un elemento del buffer. */
        public char getElement()
        {
            char element;
            SemaphoreData.Wait();
            lock (buffer.SyncRoot)
            {
                element = buffer[firstElement];
                firstElement = (firstElement + 1) % buffer.Length;
                elements--;
            }
            SemaphoreSpace.Release();
            return element;
        }
    }
}