#include <stdio.h>
#include <string.h>
#include <windows.h>

int main(int argc, char *argv[])
{
  /* Attributi di sicurezza per la pipe */
  SECURITY_ATTRIBUTES secattr; 
  memset((void *)&secattr, 0, sizeof(secattr));
  secattr.nLength = sizeof(secattr);
  secattr.bInheritHandle = TRUE;

  /* Creazione pipe */
  HANDLE rPipe, wPipe;
  CreatePipe(&rPipe, &wPipe, &secattr, 0);

  /* Informazioni per l'avvio del processo Produttore */
  STARTUPINFO sInfoProd; 
  memset((void *)&sInfoProd, 0, sizeof(sInfoProd));
  PROCESS_INFORMATION pInfoProd;
  memset((void *)&pInfoProd, 0, sizeof(pInfoProd));
  sInfoProd.cb = sizeof(sInfoProd);
  sInfoProd.dwFlags |= STARTF_USESTDHANDLES;
  sInfoProd.hStdInput = GetStdHandle(STD_INPUT_HANDLE);
  /* Collega la pipe allo stream di Output */
  sInfoProd.hStdOutput = wPipe;
  /* Collega lo stream di Errore all'output su schermo,
     lo useremo per stampare i messaggi */
  sInfoProd.hStdError = GetStdHandle(STD_OUTPUT_HANDLE);
 
  /* Crea il processo Produttore */
  if (!CreateProcess(0, (LPSTR)"Producer.exe 100", 0, 0, TRUE, \
      NORMAL_PRIORITY_CLASS |CREATE_NEW_CONSOLE, 0, 0, &sInfoProd, &pInfoProd)){
    printf("Errore nella creazione del processo produttore\n");
    return 1;
  }
  /* Informazioni per l'avvio del processo Consumatore */
  STARTUPINFO sInfoCons;
  memset((void *)&sInfoCons, 0, sizeof(sInfoCons));
  PROCESS_INFORMATION pInfoCons;
  memset((void *)&pInfoCons, 0, sizeof(pInfoCons));
  sInfoCons.cb = sizeof(sInfoCons);
  sInfoCons.dwFlags |= STARTF_USESTDHANDLES;
  /* Collega la pipe allo stream Input */
  sInfoCons.hStdInput = rPipe;
  /* Collega lo stream di Output all'output su schermo */
  sInfoCons.hStdOutput = GetStdHandle(STD_OUTPUT_HANDLE);
  /* Collega allo Standard Error l'input da tastiera.  un brutto trucco
     per poter aspettare la pressione di un tasto per terminare il
     processo consumatore */
  sInfoCons.hStdError = GetStdHandle(STD_INPUT_HANDLE);
  /* Crea il processo Consumatore */
  if (!CreateProcess(0, (LPSTR)"consumer.exe", 0, 0, TRUE, \
      NORMAL_PRIORITY_CLASS |CREATE_NEW_CONSOLE, 0, 0, &sInfoCons, &pInfoCons)){
    printf("Errore nella creazione del processo consumatore\n");
    return 1;
  }

  /* Qui la pipe non ci serve pi */
  CloseHandle(wPipe);
  CloseHandle(rPipe);
  
  /* Aspetta che i due processi terminino */
  WaitForSingleObject(pInfoCons.hProcess, INFINITE);
  CloseHandle(pInfoCons.hProcess);
  CloseHandle(pInfoCons.hThread);
  WaitForSingleObject(pInfoProd.hProcess, INFINITE);
  CloseHandle(pInfoProd.hProcess);
  CloseHandle(pInfoProd.hThread);

  printf("Esecuzione del programma terminata\n");
  return 0;

}
