#include <stdio.h>
#include <windows.h>
#include <math.h>
#include <time.h>

int main(int argc, char *argv[])
{
  /* Valore da ricevere attraverso la pipe */
  char value;
  /* Buffer per la scrittura in output */
  char buffer[512];
  /* Caratteri presenti nel buffer */
  int length;
  /* Valori da produrre, indice */
  int i, nValues;
  /* Byte scritti con WriteFile */
  DWORD dwWritten; 
  /* Handle per l'I/O */
  HANDLE hStdout, hStderr;

  /* Standard Output. Il processo padre lo collega alla pipe */
  hStdout = GetStdHandle(STD_OUTPUT_HANDLE);
  /* Standard Error. Il processo padre lo collega all'output
     su schermo per poter stampare i messaggi */
  hStderr = GetStdHandle(STD_ERROR_HANDLE);

  if (argc < 2){
    length = sprintf(buffer, "Produttore. Argomento mancante: numero di elementi da produrre\n");
    WriteFile(hStderr, buffer, length, &dwWritten, NULL);
    return 1;
  }
  if (sscanf(argv[1], "%d", &nValues) < 1){
    length = sprintf(buffer, "Produttore: numero di elementi da produrre non valido\n");
    WriteFile(hStderr, buffer, length, &dwWritten, NULL);
    return 1;
  }

  srand(time(NULL));
  for(i = 0; i <= nValues; i++){
    if (i < nValues)
      value = (char)(65 + ((int)(rand() % 25)));
    else
      value = '0';
    WriteFile(hStdout, &value, 1, &dwWritten, NULL);
    length = sprintf(buffer, "Produttore: ho inserito il valore %c\n", value);
    WriteFile(hStderr, buffer, length, &dwWritten, NULL);
  }

  length = sprintf(buffer, "Produttore: esecuzione terminata\n");
  WriteFile(hStderr, buffer, length, &dwWritten, NULL);
  getchar();
  return 0;
}
