import java.lang.Thread;
import java.lang.Math;

/* Produttore. Genera caratteri casuali e li inserisce nel buffer a ciclo continuo. 
   Generato il numero massimo di valori inserisce 0 (zero) nel buffer per indicare al
   consumatore che l'esecuzione  terminata */
class Producer implements Runnable{
  private SynchronizedBuffer buffer;
  private int nValues;

  public Producer(SynchronizedBuffer buffer, int nValues){
    this.buffer = buffer;
    this.nValues = nValues;
  }
  
  public void run(){
    char value;
    int i = 0;
    System.out.println("Produttore: esecuzione iniziata");
    do{
      try{
        if (i < nValues)
          value = (char)(65 + ((int)(Math.random() * 25)));
        else
          value = '0';
        buffer.addElement(value);
        System.out.println("Produttore: ho inserito il valore " + value);
        i++;
      }catch(BufferException E){
        System.out.println("Produttore: buffer pieno, aspetto!");
        try{
          Thread.sleep(20);
        }catch(InterruptedException iE){}
      }
    }while(i <= nValues);
    System.out.println("Produttore: esecuzione terminata");
  }
}