import java.lang.Exception;

public class SynchronizedBuffer{
  /* Array che contiene gli elementi del buffer */
  private char buffer[];
  /* Prossimo elemento da scrivere */
  private int nextElement = 0;
  /* Primo elemento da leggere */
  private int firstElement = 0;
  /* Elementi scritti sul buffer */
  private int elements = 0;

  public SynchronizedBuffer(int elements){
    buffer = new char[elements];
  }
  
  /* Aggiunge un elemento al buffer. Genera un'eccezione se il buffer  pieno */
  public synchronized void addElement(char value) throws BufferException{
    if (elements == buffer.length){
      throw new BufferException("Array pieno");
    }else{
      buffer[nextElement] = value;
      nextElement = (nextElement + 1) % buffer.length;
      elements++;
    }
  }

  /* Restituisce un elemento del buffer. Genera un'eccezione se il buffer  vuoto */  
  public synchronized char getElement() throws BufferException{
    if (elements == 0){
      throw new BufferException("Array vuoto");
    }else{
      char element = buffer[firstElement];
      firstElement = (firstElement + 1) % buffer.length;
      elements--;
      return element;
    }
  }
}